"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.NodesState = void 0;
const consts_1 = require("./consts");
class State {
    constructor() {
        this.setState();
    }
    ;
    setState() {
        if (!this.state) {
            this.state = {
                nodes: {
                    byCaller: {},
                    byId: {}
                },
                id: 1,
                group: 0
            };
        }
    }
    ;
    setCaller(caller) {
        this.caller = caller;
    }
    ;
    addNode(node) {
        if (!this.caller) {
            throw new Error('[NodesState.addNodes] Caller is not set');
        }
        if (!this.state.nodes.byCaller[this.caller]) {
            this.state.nodes.byCaller[this.caller] = [];
        }
        this.state.nodes.byCaller[this.caller].push(node);
        this.state.nodes.byId[node[consts_1.KEYS.id]] = node;
    }
    ;
    getNodes(caller) {
        if (caller) {
            return this.state.nodes.byCaller[caller] || [];
        }
        if (!this.caller) {
            throw new Error('[NodesState.getNodes] Caller is not defined');
        }
        return this.state.nodes.byCaller[this.caller] || [];
    }
    ;
    getNodesByIds(ids) {
        return ids.map(id => {
            return this.getNodeById(id);
        }).filter(node => !!node);
    }
    ;
    getNodeById(id) {
        return this.state.nodes.byId[id];
    }
    ;
    incrementId() {
        this.state.id++;
        return this.state.id;
    }
    ;
    incrementGroup() {
        this.state.group++;
        return this.state.group;
    }
    ;
    getId() {
        return this.state.id;
    }
    ;
    getNodeList(byId) {
        return byId ? this.state.nodes.byId : this.state.nodes.byCaller;
    }
    reset() {
        this.caller = null;
        this.state = {
            nodes: {
                byCaller: {},
                byId: {}
            },
            id: 1,
            group: 0
        };
    }
    ;
}
;
class NodesState {
    static getInstance() {
        if (!this.instance) {
            this.instance = new State();
        }
        return this.instance;
    }
}
exports.NodesState = NodesState;
;
//# sourceMappingURL=State.js.map