"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PostfixStack = void 0;
class PostfixStack {
    constructor() {
        this.outputIndex = 0;
        this.cache = {
            output: (symbol) => {
                const id = symbol + ++this.outputIndex;
                this.parentOutput[id] = this.output;
                this.output = [];
                this.operators.push(id);
                this.arguments[id] = [];
            },
            // optional type is used by functions otherwise used by predicate
            restore: (cacheId, type) => {
                const currentStack = this.output;
                this.output = this.parentOutput[cacheId];
                if (type) {
                    this.output.push({ type, value: this.arguments[cacheId] });
                }
                else {
                    //@ts-ignore TODO
                    this.output.push(currentStack);
                }
                delete this.parentOutput[cacheId];
            },
            // used by groupings
            merge: (cacheId) => {
                const currentStack = this.output;
                this.output = [...this.parentOutput[cacheId], ...currentStack];
                delete this.parentOutput[cacheId];
            },
            argument: (cacheId) => {
                if (this.output.length) {
                    this.arguments[cacheId].push(this.output.length > 1 ? this.output : this.output[0]);
                    this.output = [];
                }
            }
        };
        this.operators = [];
        this.output = [];
        this.parentOutput = {};
        this.arguments = {};
    }
    ;
    reset() {
        this.operators = [];
        this.output = [];
        this.arguments = {};
        this.parentOutput = {};
        this.outputIndex = 0;
    }
    ;
}
exports.PostfixStack = PostfixStack;
//# sourceMappingURL=Stack.js.map