import { tNode, tNodesState, tStack } from "./types";
export declare const nodesOps: {
    tests: {
        exists: (id: number) => boolean;
        isEqual: (node1: tNode, node2: tNode) => boolean;
        equal: {
            object: (node1: tNode, node2: tNode) => boolean;
            array: (node1: tNode, node2: tNode) => boolean;
        };
    };
    get: {
        root: (nodes: tNode[]) => tNode[];
        byName: (nodes: tNode[], name?: string) => tNode[];
        byGroup: (nodes: tNode[], group: any) => tNode[];
        byParentId: (nodes: tNode[], parentId: any) => tNode[];
        byDepth: (nodes: tNode[], depth: any) => tNode[];
        descendants: (current: tNode, nodeName?: string) => tNode[];
        ancestors: (current: tNode, nodeName?: string) => tNode[];
        siblings: (current: tNode, nodeName?: string) => tNode[];
        children: (current: tNode, nodeName?: string) => tNode[];
        parent: (current: tNode, nodeName?: string) => tNode[];
        nodeList: (byId: boolean) => tNodesState['nodes']['byId'] | tNodesState['nodes']['byCaller'];
    };
    reconstruct: (nodes: tNode[]) => import("./types").tJSON;
};
export declare const opFunc: {
    /**
     *
     * @param context the caller name
     * @param expectedTypes array of string of allowable types
     * @param item the interrogated stack item
     * @returns the actual value
     */
    getValueByType: (context: string, expectedTypes: string[], item: tStack) => any;
    validate: {
        exists: (item: tStack, context: string) => void;
        /**
         * Validate the length of the number of nodes in the value list
         * If invalid, throws an error
         *
         * @param expectedLength
         *  the length of the nodes' value expected
         * @param item
         *  the stack item type in the format {type, value}
         * @param symbol?
         *  optional symbol used to test against (>=, >, <=, <, =).
         *  If not defined it is tested against the expectedLength
         * @param context?
         *  optional context (original caller)
         * @returns
         *  boolean
         */
        numberOfNodeItems: (item: tStack, expectedLength: number, symbol?: string, context?: string) => boolean;
        areNumbers: (item: tStack, context: string) => void;
    };
};
export declare const throwError: (context: any, msg: any) => never;
//# sourceMappingURL=Util.d.ts.map